#include <iostream>
#include <math.h>
#include <time.h>
#include <iostream>

///FUNCION DE EVALUACION
float evaluar(int*Solucion,float*P,float*V,int i, int j){
  float suma = 0;
  float mult = 1;
  for(int l=0;l<j;l++){
    for(int k=0;k<i;k++){
      mult = mult*(pow((1-P[k*j+l]),Solucion[k*j+l]));

    }
    suma += V[l]*mult;
    mult=1;
  }
  return suma;
}


int main() {

  ///INSTANCIACIÓN
  int i,j; //Cantidad de armas y objetivos
  std::cin >> i >> j;
  int* Solucion = new int[(i*j)]; //Representación de solución

  int* M = new int[i]; //Cantidad de armas
  float* V = new float[j]; //Cantidad de objetivos/daño realizado
  for(int k=0;k<i;k++){
    std::cin >> M[k];
  }
  for(int k=0;k<j;k++){
    std::cin >> V[k];
  }

  float* P = new float[(i*j)]; // Representación de probabilidades
  for(int k=0;k<(i*j);k++){
    std::cin >> P[k];
  }



  ///RESOLUCIÓN

  std::cout << "Armas unicas: ";
  std::cout << i;
  std::cout << "\n";

  std::cout << "Objetivos unicos: ";
  std::cout << j;
  std::cout << "\n";

  std::cout << "Cantidad de armas por tipo:\n";
  for(int k=0;k<i;k++){
    std::cout << k;
    std::cout << ": ";
    std::cout << M[k];
    std::cout << "\n";
  }

  std::cout << "Cantidad de objetivos por tipo:\n";
  for(int k=0;k<j;k++){
    std::cout << k;
    std::cout << ": ";
    std::cout << V[k];
    std::cout << "\n";
  }

  ///Greddy

  //Inicializar solucion
  for(int l=0;l<j;l++){
    for(int k=0;k<i;k++){
      Solucion[k*j+l] = 0;
    }
  }

  std::cout << "Evaluacion Inicial: " << evaluar(Solucion,P,V,i,j) << "\n";

  //inicializar arreglo disponibles
  int* Disponibles = new int[i];
  for(int k=0;k<i;k++){
    Disponibles[k] = M[k];
  }

  //inicializar arreglo SolActual
  float* SolActual = new float[j];
  for(int k=0;k<j;k++){
    SolActual[k] = V[k];
  }

  //inicializacion de variables
  int conteo=0;
  float max=0;
  float pMax=0;
  int indexi=0;
  int indexj=0;
  for(int k=0;k<i;k++){
    conteo+=Disponibles[k];
  }

  //Mientras hayan armas asignar
  while(conteo > 0){
    conteo=0;
    //buscar al indice j con mayor cantidad de objetivos
    for(int k=0;k<j;k++){
      if(SolActual[k] > max){
        max=SolActual[k];
        indexj=k;
      }
    }
    max=0;

    //buscar al indice i, que le queden armas, que tenga mayor
    //probabilidad de derribar al objetivo de indice j
    for(int k=0;k<i;k++){
      if(P[k*j+indexj] > pMax){
        if (Disponibles[k]>0){
          pMax = P[k*j+indexj];
          indexi=k;
        }
      }
    }
    pMax=0;

    //Asignar a solucion, ajustar Disponibles, setear SolActual con el cambio
    //e iterar de nuevo
    Disponibles[indexi]-=1;
    SolActual[indexj] = SolActual[indexj]*(1-P[indexi*j+indexj]);
    Solucion[indexi*j+indexj]+=1;


    //contar cuantas armas quedan por asignar
    for(int k=0;k<i;k++){
      conteo+=Disponibles[k];
    }

  }

  //esto solia imprimir la matriz, pero queda muy engorroso en instancias
  //mas grandes
  /*std::cout << "Solucion Final" << '\n';
  for (int k=0;k<i;k++){
    std::cout << "[ ";
    for (int l=0;l<j;l++){
      std::cout << Solucion[k*j+l];
      std::cout << " - ";
    }
    std::cout << "]\n";
  }*/

  //Evaluar solucion
  std::cout << "Evaluacion Final: "  << evaluar(Solucion,P,V,i,j) << "\n";

  //Liberar memoria
  delete(Solucion);
  delete(M);
  delete(V);
  delete(P);
  delete(SolActual);
  delete(Disponibles);

  return 0;
}
